package asia.tcrs.ccnp.chemicraftnext.core.block;

import asia.tcrs.ccnp.chemicraftnext.core.ChemiCraftCore;
import asia.tcrs.ccnp.chemicraftnext.core.debug.DebugTick;
import asia.tcrs.ccnp.chemicraftnext.core.tileentity.TileEntityPyrolysisTable;
import net.minecraft.block.BlockContainer;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.Icon;
import net.minecraft.world.World;

public class BlockPyrolysisTable extends BlockContainer {

	public Icon topIcon;
	public Icon bottomIcon;
	public Icon globalIcon;

	public BlockPyrolysisTable(int par1, Material par2Material) {
		super(par1, par2Material);
		this.setCreativeTab(ChemiCraftCore.creativeTabChemiCraft);
	}

	@Override
	public boolean onBlockActivated(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, int par6, float par7, float par8, float par9){
		par5EntityPlayer.openGui(ChemiCraftCore.instance, ChemiCraftCore.instance.guiPyrolysisTableID, par1World, par2, par3, par4);
		return true;
	}



	@Override
	public void registerIcons(IconRegister par1IconRegister) {
		this.topIcon = par1IconRegister.registerIcon(ChemiCraftCore.CCTABLE + "PyrolysisTable");
		this.bottomIcon = par1IconRegister.registerIcon(ChemiCraftCore.CCTABLE + "Bottom");
		this.globalIcon = par1IconRegister.registerIcon(ChemiCraftCore.CCTABLE + "Side");
	}



	@Override
	public void breakBlock(World par1World, int par2, int par3, int par4, int par5, int par6) {
		TileEntity tileentity = par1World.getBlockTileEntity(par2, par3, par4);
		if (tileentity != null) {
			DebugTick.removeDebugData("PyrolysisTable" +
					"(x:" + tileentity.xCoord +
					" y:" + tileentity.yCoord +
					" z:" + tileentity.zCoord + ")");
		}
		super.breakBlock(par1World, par2, par3, par4, par5, par6);
	}



	@Override
	public Icon getIcon(int par1, int par2) {
		if(par1 == 0){
			return this.bottomIcon;
		}else if(par1 == 1){
			return this.topIcon;
		}else{
			return this.globalIcon;
		}
	}

	@Override
	public TileEntity createNewTileEntity(World var1) {
		return new TileEntityPyrolysisTable();
	}

}
