package asia.tcrs.ccnp.chemicraftnext.core.client;

import asia.tcrs.ccnp.chemicraftnext.ChemiCraft;
import asia.tcrs.ccnp.chemicraftnext.core.container.ContainerElectrolysisTable;
import asia.tcrs.ccnp.chemicraftnext.core.debug.DebugTick;
import asia.tcrs.ccnp.chemicraftnext.core.gui.GuiChemicalCombinationTable;
import asia.tcrs.ccnp.chemicraftnext.core.gui.GuiChemicalCraftingTable;
import asia.tcrs.ccnp.chemicraftnext.core.gui.GuiElectrolysisTable;
import asia.tcrs.ccnp.chemicraftnext.core.gui.GuiPyrolysisTable;
import asia.tcrs.ccnp.chemicraftnext.core.gui.GuiToolAndWeaponCraftingTable;
import asia.tcrs.ccnp.chemicraftnext.core.system.CommonProxy;
import asia.tcrs.ccnp.chemicraftnext.core.tileentity.TileEntityChemicalCombinationTable;
import asia.tcrs.ccnp.chemicraftnext.core.tileentity.TileEntityChemicalCraftingTable;
import asia.tcrs.ccnp.chemicraftnext.core.tileentity.TileEntityElectrolysisTable;
import asia.tcrs.ccnp.chemicraftnext.core.tileentity.TileEntityPyrolysisTable;
import asia.tcrs.ccnp.chemicraftnext.core.tileentity.TileEntityToolAndWeaponCraftingTable;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import net.minecraftforge.client.MinecraftForgeClient;
import cpw.mods.fml.client.FMLClientHandler;
import cpw.mods.fml.common.registry.TickRegistry;
import cpw.mods.fml.relauncher.Side;

public class ClientProxy extends CommonProxy {

	@Override
	public void registerRenderInformation() {
		MinecraftForgeClient.preloadTexture(ChemiCraft.GUI_PYROLYSIS_TEXTURE);
		MinecraftForgeClient.preloadTexture(ChemiCraft.GUI_ELECTROLYSIS_TEXTURE);
		MinecraftForgeClient.preloadTexture(ChemiCraft.GUI_CHEMICALCOMBINATION_TEXTURE);
		MinecraftForgeClient.preloadTexture(ChemiCraft.GUI_CHEMICALCRAFTING_TEXTURE);
		MinecraftForgeClient.preloadTexture(ChemiCraft.GUI_TOOLANDWEAPONCRAFTING_TEXTURE);
		MinecraftForgeClient.preloadTexture(ChemiCraft.ENTITY_PARTICLE_TEXRURE);
	}


	@Override
	public Object getClientGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z) {
		if (!world.blockExists(x, y, z))
			return null;

		TileEntity tileEntity = world.getBlockTileEntity(x, y, z);
		if (tileEntity instanceof TileEntityPyrolysisTable) {
			return new GuiPyrolysisTable(player, (TileEntityPyrolysisTable) tileEntity);
		}else if(tileEntity instanceof TileEntityElectrolysisTable){
			return new GuiElectrolysisTable(player, (TileEntityElectrolysisTable) tileEntity);
		}else if(tileEntity instanceof TileEntityChemicalCombinationTable){
			return new GuiChemicalCombinationTable(player, (TileEntityChemicalCombinationTable) tileEntity);
		}else if(tileEntity instanceof TileEntityToolAndWeaponCraftingTable){
			return new GuiToolAndWeaponCraftingTable(player, (TileEntityToolAndWeaponCraftingTable) tileEntity);
		}else if(tileEntity instanceof TileEntityChemicalCraftingTable){
			return new GuiChemicalCraftingTable(player, (TileEntityChemicalCraftingTable) tileEntity);
		} else if (tileEntity instanceof TileEntityElectrolysisTable) {
			return new ContainerElectrolysisTable(player, (TileEntityElectrolysisTable) tileEntity);
		}
		return null;
	}


	@Override
	public World getClientWorld() {
		return FMLClientHandler.instance().getClient().theWorld;
	}

	@Override
	public void registerTickHandler() {
		TickRegistry.registerTickHandler(new DebugTick(), Side.CLIENT);
	}

}
